from http.client import HTTPSConnection
from base64 import b64encode
import urllib.parse
import sys

# Command-line parameters:
#    ACCT TOKEN FROM TO MESSAGE

if (len(sys.argv) < 6):
	print( "%s: too few arguments; expected: ACCT TOKEN FROM TO MESSAGE\n" % sys.argv[0] )
	exit( 1 )

# Assign arguments
(self_name, acct, token, from_number, to_number, message ) = sys.argv

# Prepare connection and POST data
try:
	conn = HTTPSConnection( 'api.twilio.com' )
	userAndPass = b64encode( bytearray( "%s:%s" % ( acct, token ),"ascii" ) ).decode( "ascii" )
	headers = {
		"Content-type": "application/x-www-form-urlencoded", 
		"Accept": "application/json", 
		'Authorization' : 'Basic %s' %  userAndPass 
	}
	params = urllib.parse.urlencode(
		{
			'To': to_number,
			'From': from_number,
			'Body': message
		}
	)
	uri = "/2010-04-01/Accounts/%s/Messages.json" % acct

	conn.request( "POST", uri, params, headers )
	response = conn.getresponse( )
except:
	# 'Catch all' block
	print( "Exception: %s\n" % sys.exc_info()[0] )
	exit( 250 )
else:
	# If no failure occurred: print data or error block and exit
	# Normally, 20x response code should return
	if ( response.status >= 200 ) and ( response.status < 300 ):
		print( response.status )
		exit( 0 )
	else:
	# Otherwise, print the JSON response, code/reason and report error
		data = response.read( )
		print( data )
		print( response.status, response.reason )
		exit( response.status )
